org.apache.xpath.functions

## Class FunctionMultiArgs

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.functions.Function
    - - org.apache.xpath.functions.FunctionOneArg
      - - org.apache.xpath.functions.Function2Args
        - - org.apache.xpath.functions.Function3Args
          - - org.apache.xpath.functions.FunctionMultiArgs

All Implemented Interfaces:
  java.io.Serializable, SourceLocator, ExpressionNode, ExpressionOwner, XPathVisitable

Direct Known Subclasses:
  FuncConcat

    public class FunctionMultiArgs
    extends Function3Args

Base class for functions that accept an undetermined number of multiple arguments.

See Also:
  Serialized Form
Usage:
  **For advanced use only**

### Constructor Summary

Constructors
Constructor and Description
`FunctionMultiArgs()`

### Method Summary

Methods
`void` `callArgVisitors(XPathVisitor visitor)` Call the visitors for the function arguments.
`boolean` `canTraverseOutsideSubtree()` Tell if this expression or it's subexpressions can traverse outside the current subtree.
`void` `checkNumberArgs(int argNum)` Check that the number of arguments passed to this function is correct.
`boolean` `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`void` `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
`Expression[]` `getArgs()` Return an expression array containing arguments at index 3 or greater.
`void` `setArg(Expression arg, int argNum)` Set an argument expression for a function.

### Methods inherited from class org.apache.xpath.functions.Function3Args

`getArg2`

### Methods inherited from class org.apache.xpath.functions.Function2Args

`getArg1`

### Methods inherited from class org.apache.xpath.functions.FunctionOneArg

`getArg0, getExpression, setExpression`

### Methods inherited from class org.apache.xpath.functions.Function

`callVisitors, execute, postCompileStep`

### Methods inherited from class org.apache.xpath.Expression

`asIterator, asIteratorRaw, asNode, assertion, bool, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### FunctionMultiArgs

    public FunctionMultiArgs()

### Method Detail

#### getArgs

    public Expression[] getArgs()

Return an expression array containing arguments at index 3 or greater.

Returns:
  An array that contains the arguments at index 3 or greater.

#### setArg

    public void setArg(Expression arg,
              int argNum)
                throws WrongNumberArgsException

Set an argument expression for a function. This method is called by the XPath compiler.

Overrides:
  `setArg` in class `Function3Args`
Parameters:
  `arg` - non-null expression that represents the argument.
  `argNum` - The argument number index.
Throws:
  `WrongNumberArgsException` - If a derived class determines that the number of arguments is incorrect.

#### fixupVariables

    public void fixupVariables(java.util.Vector vars,
                      int globalsSize)

This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.

Overrides:
  `fixupVariables` in class `Function3Args`
Parameters:
  `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

#### checkNumberArgs

    public void checkNumberArgs(int argNum)
                         throws WrongNumberArgsException

Check that the number of arguments passed to this function is correct.

Overrides:
  `checkNumberArgs` in class `Function3Args`
Parameters:
  `argNum` - The number of arguments that is being passed to the function.
Throws:
  `WrongNumberArgsException`

#### canTraverseOutsideSubtree

    public boolean canTraverseOutsideSubtree()

Tell if this expression or it's subexpressions can traverse outside the current subtree.

Overrides:
  `canTraverseOutsideSubtree` in class `Function3Args`
Returns:
  true if traversal outside the context node's subtree can occur.

#### callArgVisitors

    public void callArgVisitors(XPathVisitor visitor)

Description copied from class: `Function`
Call the visitors for the function arguments.

Overrides:
  `callArgVisitors` in class `Function3Args`
See Also:
  `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

#### deepEquals

    public boolean deepEquals(Expression expr)

Description copied from class: `Expression`
Compare this object with another object and see if they are equal, include the sub heararchy.

Overrides:
  `deepEquals` in class `Function3Args`
Parameters:
  `expr` - Another expression object.
Returns:
  true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
See Also:
  `Expression.deepEquals(Expression)`